/*
 *  Author:  Gang Zhang
 *  History: FEb 26, 2003 Added base 64 encoder for http basic auth.
 *  Very simple file to send a http request to the specified port with user name, password
 *  and action information.   This file is used with the new config servlet to command
 *  the server from command line.
 *
 *  The code is provided as is and the author is not responsible for any 
 *  damage/desired/undesired out come.
 */

public class sendCmd{
  public static void main(String argv[]) throws Exception{
    if(argv.length!=4){
      System.out.println("wrong number of arguments, usage: java sendCmd [port] [name] [pass] [cmd]");
      return;
    }
    int port=new Integer(argv[0]).intValue();
    java.net.Socket skt=new java.net.Socket("localhost",port);
    String name=argv[1];
    String pass=argv[2];
    String cmd=argv[3];

    //it is important to append 2 CRLF at the end of this string, signal the end of http request header.

    String sndStr="GET /srvConfig/?action="+cmd+" HTTP/1.0\nAuthorization: Basic "+Base64Encoder.enc((name+":"+pass).getBytes())+"\n\n";
    skt.getOutputStream().write(sndStr.getBytes());
    System.out.println("sent "+sndStr);
    //read at least one byte to wait for resonse before close socket.
    try{skt.getInputStream().read();}catch(Exception e){}
    skt.close();
  }
}

//Just a crappy base 64 encoder, not optimized or anything.
class Base64Encoder {

  final private static char[] mTable=new char[64];
  static{
    formatTable();
  }
  //A-Z 0-25, a-z 26-51, 0-9 52-61, + 62, / 63
  final private static void formatTable(){
    mTable[0]=0;
    for(int i=0;i<62;i++){
      if( (i>=0) && (i<=25) ){
        mTable[i]=(char)('A'+i);
      }else if( (i>=26) && (i<=51) ){
        mTable[i]=(char)('a'+i-26);
      }else if( (i>=52) && (i<=61) ){
        mTable[i]=(char)('0'+i-52);
      }
    }
    mTable[62]='+';
    mTable[63]='/';
  }
  public static String enc(byte[] encStr){
    StringBuffer sb=new StringBuffer(1024);   //set this size larger if you know you got large data.
                                              //if data size is known, then just set this to data size.
    short shift=0;
    int i=0;
    boolean done=false;
    while(i<encStr.length){
      //out 1
      int c=(encStr[i]>>2)&0x3f;
      sb.append(mTable[c]);
      c=encStr[i]<<4;
      i++;
      //out 2
      if(i<encStr.length)
        c|=(encStr[i]>>4)&0x0f;
      else
        done=true;
      c&=0x3f;
      sb.append(mTable[c]);
      if(done){
        sb.append("==");
        break;
      }
      //out 3
      c=(encStr[i]<<2)&0x3c;
      i++;
      if(i<encStr.length)
        c|=(encStr[i]>>6)&0x03;
      else
        done=true;
      sb.append(mTable[c]);
      if(done){
        sb.append("=");
        break;
      }
      //out 4;
      c=encStr[i]&0x3f;
      sb.append(mTable[c]);
      i++;
      if(i>encStr.length)break;
    }
    return sb.toString();
  }
}
