/*
//  File  : UploadServlet.java
//  Author: Gang Zhang
//  Date  : 06/01/1999
//  Desc  : Servlet that loads file to server
//  Revisions:  GZ, 10/08/1999, speed ups
//              GZ, Aug 19, 2003 small re-design.
//  Desc:  just a real simple uploader.
//
//  reference:  http://www.cis.ohio-state.edu/rfc/rfc2388.txt
//
//Debug GZ: when diling with mutipart content, with binary files,
    <form ENCTYPE="multipart/form-data" action=http://localhost/servlets/SurveyServlet method=POST>
      <input type=hidden name=survey value=Survey01Results>
	<INPUT TYPE="file" NAME="userfile" SIZE=40><BR>

   getParameterName will return a enumator with no keys....

   Also, we must read the input, otherwise, error will happen....
   //to use, call gp.parse(), then
   //len=gp.readFile();
   //fo.write(gp.getBuf(),0,i);, continue till len<0
//
*/

import java.io.*;
import java.util.*;

import javax.servlet.*;
import javax.servlet.http.*;
import com.BajieSoft.util.gMultiMimeParser;

public class UploadServlet extends HttpServlet
{
  ServletConfig m_config;
  private File resultsDir=null;
  public void init(ServletConfig config)
    throws ServletException
  {
    super.init(config);
    m_config=config;
    //Jul 25, 2002  removed to force it to use temp dir for security reasons
    //              if you wish to customize, either edit servlet's property
    //              or add a UploadServlet.params.properties file in the same directory
    //              and add line resultsDir=dir in the file.  Make sure the directory
    //              is not in web tree, else people can upload jsp file and execute them!!
    //
    //String resultsDirStr = getInitParameter("resultsDir");
    //if(resultsDirStr==null)
      resultsDir=(File)config.getServletContext().getAttribute("javax.servlet.context.tempdir");
    //else
    //  resultsDir=new File(resultsDirStr);
  }

  public void doGet(HttpServletRequest req, HttpServletResponse res)
   throws ServletException, IOException
  {
    PrintWriter toClient = res.getWriter();
    toClient.println("<br>get operation!!<br>");
    doPost(req,res);
  }

  // write a -1 as total to finish file
  private void showProg(long total,int pcnt,final HttpServletRequest req,final PrintWriter toClient){
    StringBuffer wstr = new StringBuffer(1024);
                 String uaStr = req.getHeader("User-Agent");
                 boolean ie = false;
                 if (uaStr != null) {
                   if (uaStr.indexOf("MSIE") > 0)
                     ie = true;
                 }
                 wstr.append("<script>");
                 if (!ie)
                   wstr.append("fstats=document.getElementById(\"fstats\");");
                 if (total == -1) {
                   wstr.append("fstats.innerHTML=\"<table width=90%><tr bgcolor=#7f7f7f><td bgcolor=blue>Done</td></tr></table>\";</script>");
                 }
                 else {
                   wstr.append("fstats.innerHTML=\"<table width=90%><tr bgcolor=#7f7f7f><td bgcolor=blue width=");
                   wstr.append(pcnt);
                   wstr.append("%>").append(total).append(
                       "</td><td >&nbsp</td></tr></table>\";</script>");
                 }
                 toClient.println(wstr.toString());
                 toClient.flush();
  }
  /**
   * Write survey results to output file in response to the POSTed
   * form.  Write a "thank you" to the client.
   */
  public void doPost(final HttpServletRequest req, final HttpServletResponse res)
	  throws ServletException, IOException
  {
    // first, set the "content type" header of the response
    res.setContentType("text/html");

    //Get the response's PrintWriter to return text to the client.
    final PrintWriter toClient = res.getWriter();
    gMultiMimeParser.fileWriter lsn=new gMultiMimeParser.fileWriter(){
          long startTime;
          long totalfilelen = 0;
          public OutputStream getOutputStream(final String fileName,final String fieldName,final String contentType)
            throws java.io.IOException
          {
            String fullOrigFilename = fileName;
            if (fullOrigFilename == null || fullOrigFilename.length() == 0)
              return null;
            toClient.println("filename= " + fullOrigFilename + "<br>");
            String fname = "";
            {
              int ind=fullOrigFilename.lastIndexOf('\\');
              if(ind<0){
                ind=fullOrigFilename.lastIndexOf('/');
              }
              if(ind<0)
                fname=fullOrigFilename;
              else
                fname=fullOrigFilename.substring(ind+1);
              fname=fname.trim();
            }
            if(fname.length()==0){
              toClient.println("Bad filename "+fullOrigFilename);
              return null;
            }

            //String uploadFilePath=resultsDir+req.getRemoteAddr()+"_"+req.getRemoteHost()+"_"+fname;
            File uploadFilePath = new File(resultsDir, fname);
            final FileOutputStream fo ;
            try{
              fo= new FileOutputStream(uploadFilePath);
            }catch(java.io.FileNotFoundException fe){
              throw new java.io.IOException("File not found "+fe);
            }
            synchronized (this) {
              java.io.Writer logger = null;
              try {
                logger = new java.io.OutputStreamWriter(new FileOutputStream(
                    "uploads.log"));
                logger.write(req.getRemoteAddr() + ":" + req.getRemoteHost() +
                             " => " + uploadFilePath);
              }
              catch (Exception e) {}
              finally {
                try {
                  logger.close();
                }
                catch (Exception e) {}
              }

            }
            //commented out for more security
            toClient.println("Recording file to ::" + uploadFilePath + "<br>");
            toClient.flush();
            startTime = System.currentTimeMillis();
            totalfilelen = 0;
            /*
            totalfilelen = gp.WritePutFile(fo, lsn);
            fo.close();
            */
           final long reportThreshold=req.getContentLength()/100>50*1024?req.getContentLength()/100:50*1024;
           return new OutputStream(){
             long total=0;
             int accu = 0;
             int pcnt = 0;
             public void write(byte[] buf,int off,int len) throws java.io.IOException{
               fo.write(buf,off,len);
               totalfilelen+=len;
               total += len;
               accu += len;
               boolean ok = false;
               if (req.getContentLength() > 0) {
                 if (accu * 100 / req.getContentLength() > 0) {
                   pcnt = (int)(total * 100 / req.getContentLength());
                   ok = true;
                   accu = 0;
                 }
               }
               else {
                 if (accu > reportThreshold) {
                   accu = 0;
                   ok = true;
                 }
               }
               if (len == -2) {
                 ok = true;
               }
               if (ok) {
                 showProg(total,pcnt,req,toClient);
               }
             }
             public void write(int b){}
             public void close() throws java.io.IOException {
               fo.close();
               toClient.println("<br>File length is " + totalfilelen + " bytes<br>");
               long totalTime = System.currentTimeMillis() - startTime;
               if (totalTime == 0)
                 totalTime = 1;
               toClient.println("<br>speed is "+(totalfilelen*1000/totalTime)+" bytes/sec<br>");
             }
           };
          }
	};
    if(toClient==null)return;
    toClient.println("<html>");
    toClient.println("<head><title>Thank you!</title></head>");
    toClient.println("<body bgcolor=#aaaaee>");

    toClient.println("<div id=fstats><table width=90%><tr bgcolor=#7f7f7f><td bgcolor=blue width=0%>0%</td><td >&nbsp</td></tr></table></div>");
    try{
      gMultiMimeParser gp=new gMultiMimeParser(req.getInputStream());
      gp.doParse(lsn);      
      showProg(-1,100,req,toClient);
      //how to get parameters
      java.util.Enumeration keys=gp.getParameterNames();
      while(keys.hasMoreElements()){
        String key=(String)keys.nextElement();
        // String val=gp.getParameter(key);  //get single value
        String val[]=gp.getParameterValues(key);
        for(int j=0;j<val.length;j++){
          System.out.println("got key "+key+" = "+val[j]);
        }
      }
    }catch(Throwable e){
      e.printStackTrace();
      toClient.println("<br>Warning: Can't write file "+e+"<br>");
    }

    try{
      toClient.println("<br>Remote IP is " + req.getRemoteAddr());
      if (req.getRemoteHost() != null)
        toClient.println("Remote host: " + req.getRemoteHost() + "<br>");
      toClient.println("<br>size is :" + req.getContentLength() + "<BR>");
      //toClient.println("<title>Thank you!</title>");
      toClient.println("<br>Thank you for your uploading!<br>");
      toClient.println("</body></html>");

      // Close the writer; the response is done
      toClient.close();
    }catch(Exception e){
      e.printStackTrace();
    }
  }
}

